console.log("Welcome to Taggz.art! Tag the web.");
let isSvgContainerVisible = true;
let isPinned = false;
let iframeSrc = `https://www.taggz.art/cgi-bin/taggz.pl?action=login_verify&tsite=${encodeURIComponent(window.location.href)}&tver=1.00&timestamp=${encodeURIComponent(Date.now())}`;
const link = document.createElement("link");
link.rel = "stylesheet";
link.type = "text/css";
link.href = chrome.runtime.getURL("styles.css");
document.head.appendChild(link);
const chromeStorage = chrome.storage.sync;
function handleUserData(userData) {
  if (userData && userData.tid && userData.tem && userData.tpw) {
    const tsite = window.location.href;
    const timestamp = Date.now();
    iframeSrc = `https://www.taggz.art/cgi-bin/taggz.pl?action=login_verify&tsite=${encodeURIComponent(tsite)}&tver=1.00&timestamp=${encodeURIComponent(timestamp)}`;
    iframeSrc += `&tid=${encodeURIComponent(userData.tid)}&tem=${encodeURIComponent(userData.tem)}&tpw=${encodeURIComponent(userData.tpw)}`;
    const iframe = document.getElementById('iframe');
    iframe.src = iframeSrc;
  } else {
    console.error('userData is missing or incomplete.');
  }
}
chromeStorage.get('userData', (result) => {
  if (chrome.runtime.lastError) {
    console.error(chrome.runtime.lastError);
  } else {
    const userData = result.userData;
    if (userData && userData.tid && userData.tem && userData.tpw) {
      handleUserData(userData);
    }
  }
});
chromeStorage.get('isSvgContainerVisible', (result) => {
  if (chrome.runtime.lastError) {
    console.error(chrome.runtime.lastError);
  } else {
    if (result.isSvgContainerVisible !== undefined) {
      isSvgContainerVisible = result.isSvgContainerVisible;
    }
    initializeToggleState();
  }
});
function handleLoginSuccess(userData) {
  localStorage.setItem('userData', JSON.stringify(userData));
  if (userData && userData.tid && userData.tem && userData.tpw && userData.tscore) {
    chromeStorage.set({ 'userData': userData }, () => {
      if (chrome.runtime.lastError) {
        console.error(chrome.runtime.lastError);
      } else {
        renderSVGs(userData.soulart);
        renderAvatarPNG(userData.tid);
        addJailBars(userData.tgame);
      }
    });
    let tid = null;
    chromeStorage.get('userData', (result) => {
      if (!chrome.runtime.lastError) {
        const userData = result.userData;
        if (userData && userData.tid && userData.tname) {
          tid = userData.tid;
          document.getElementById('tname').value = userData.tname;
          document.getElementById('tid').value = userData.tid;
          document.getElementById('tsite').value = window.location.href;
          document.getElementById('feedback_tname').value = userData.tname;
          document.getElementById('feedback_tid').value = userData.tid;
          document.getElementById('feedback_tsite').value = window.location.href;
          let showAdminIcon = false; 
          if (tid === "2" || tid === "3") {
            showAdminIcon = true; 
          }
          const adminIconHTML = showAdminIcon
            ? `<img class="taggz_icon" id="taggz_admin" src="${chrome.runtime.getURL("img/icon_admin.svg")}" alt="Admin" title="Admin Settings"/>`
            : '';
          if (showAdminIcon) {
            const taggzAdmin = document.getElementById('admin');
            if (taggzAdmin) {
              taggzAdmin.innerHTML += adminIconHTML;
            }
          }
          const adminButton = document.getElementById('taggz_admin');
          adminButton.addEventListener('click', () => {
            openAdminSidebarWithIframe(userData.tid);
          });

        }
      }
    });
    const Tlogin = document.getElementById('taggz_Tlogin-form');
    const Tcontent = document.getElementById('taggz_Tcontent');
    Tlogin.style.display = 'none';
    Tcontent.style.display = 'block';
    setTimeout(() => {
      showNavigation();
    }, 500);
    setTimeout(() => {
      hideNavigation();
    }, 1000);
    const chatButton = document.getElementById('taggz_chat');
    chatButton.addEventListener('click', () => {
      openChatSidebarWithIframe(userData.tid, userData.tname);
    });
    const followButton = document.getElementById('taggz_follow');
    followButton.addEventListener('click', () => {
      openFollowSidebarWithIframe(userData.tid);
    });
    const searchButton = document.getElementById('taggz_search');
    searchButton.addEventListener('click', () => {
      openSearchSidebarWithIframe(userData.tid);
    });
    const shopButton = document.getElementById('taggz_shop');
    shopButton.addEventListener('click', () => {
      openShopSidebarWithIframe(userData.tid);
    });
    const profileButton = document.getElementById('taggz_profile');
    profileButton.addEventListener('click', () => {
      openProfileSidebarWithIframe(userData.tid);
    });
  
  } else {
    console.error('Callback did not work for userData.');
  }
}
window.addEventListener("message", (event) => {
  if (event.data.type === "loginSuccess") {
    const userData = event.data.data;
    handleLoginSuccess(userData);
  }
});
const overlay = document.createElement("div");
overlay.id = "taggz_game-overlay-popup";
const iframe = document.createElement("iframe");
iframe.id = "iframe";
iframe.className = "taggz_login-iframe";
iframe.setAttribute('allowtransparency', 'true');
iframe.classList.add('taggz_transparent-iframe');
iframe.src = iframeSrc;
const closeButton = document.createElement("button");
closeButton.textContent = ""; 
closeButton.id = "closeButton";
overlay.innerHTML = `
<div class="taggz_Tlogin-form" id="taggz_Tlogin-form">
   ${closeButton.outerHTML}
   ${iframe.outerHTML}
</div>
<div class="taggz_Tcontent" id="taggz_Tcontent">
<div id="taggz_nav-wrapper">
  <div id="taggz_navigation" class="taggz_navigation">
    <div class="taggz_navigation_top">
      <img class="taggz_icon" id="taggz_pin-button" src="${chrome.runtime.getURL("img/icon_unpinned.svg")}" alt="Pin" title="Pin"/>
      <img id="taggz_toggle-icon" class="taggz_icon" src="${chrome.runtime.getURL("img/icon_toggle_on.svg")}" alt="Toggle On" title="Art Toggle"/>
      <img class="taggz_icon" id="taggz_search" src="${chrome.runtime.getURL("img/icon_search.svg")}" alt="Search" title="Search"/>
      <div id="taggz_avatar-container" title="My Character"></div>
      <img class="taggz_icon_lg" id="taggz_draw" src="${chrome.runtime.getURL("img/icon_tagging.svg")}" alt="Paint" title="Paint"/>
      <img class="taggz_icon" id="taggz_leaderboard" src="${chrome.runtime.getURL("img/icon_leaderboard.svg")}" alt="Leaderboards" title="Leaderboards"/>
      <img class="taggz_icon" id="taggz_chat" src="${chrome.runtime.getURL("img/icon_chat.svg")}" alt="Chat" title="Chat"/>
      <img class="taggz_icon" id="taggz_follow" src="${chrome.runtime.getURL("img/icon_follow.svg")}" alt="Following" title="Following"/>
      <img class="taggz_icon" id="taggz_shop" src="${chrome.runtime.getURL("img/icon_store.svg")}" alt="My Store" title="My Store"/>
    </div>
    <div class="taggz_footer">
      <img class="taggz_icon" id="taggz_invite_icon" src="${chrome.runtime.getURL("img/icon_invite.svg")}" alt="Invite" title="Invite"/>
      <img class="taggz_icon" id="taggz_feedback_icon" src="${chrome.runtime.getURL("img/icon_feedback.svg")}" alt="Support" title="Support"/>
      <img class="taggz_icon" id="taggz_profile" src="${chrome.runtime.getURL("img/icon_settings.svg")}" alt="Profile" title="Profile"/>
      <img class="taggz_icon" id="taggz_logout-button" src="${chrome.runtime.getURL("img/icon_logout.svg")}" alt="Logout" title="Logout"/>
      <div id="admin"></div>
    </div>
  </div>
</div>
<div id="taggz_svg-container"></div> 
<div id="taggz_sidebar">
</div>
<div id="taggz_admin_sidebar">
</div>
<div id="taggz_draw-overlay">
    <iframe id="taggz_iframe-draw" allowtransparency="true" class="transparent-iframe" name="tagging" style="background: transparent;"></iframe>
</div>
<div id="taggz_invite_modal" class="taggz_modal">
  <div id="taggz_close_invite" class="taggz_close_modal"></div>
  <form id="invite_form" action="https://taggz.art/cgi-bin/taggz.pl" method="post">
  <input type="hidden" name="action" value="invite_send">
  <input type="hidden" name="tname" id="tname" value="">
  <input type="hidden" name="tid" id="tid" value="">
  <input type="hidden" name="tsite" id="tsite" value="">
  <input type="email" name="invite_em" placeholder="Friends Email">
  <button type="submit" class="taggz_button_invite">Invite</button>
  </form>
</div>
<div id="taggz_feedback_modal" class="taggz_modal">
  <div id="taggz_close_feedback" class="taggz_close_modal"></div>
  <form action="https://taggz.art/cgi-bin/taggz.pl" method="post">
  <input type="hidden" name="action" value="feedback_save">
  <input type="hidden" name="tname" id="feedback_tname" value="">
  <input type="hidden" name="tid" id="feedback_tid" value="">
  <input type="hidden" name="tsite" id="feedback_tsite" value="">
    <div class="image-container">
      <img src="${chrome.runtime.getURL("img/icon_feedback_1.svg")}" id="feedbackImage" alt="Feedback Image">
    </div>
    <div class="slider-container">
      <input name="feedback_range" type="range" min="0" max="6" step="1" id="feedbackSlider">
      <div class="slider-value" id="sliderValue">1</div>
    </div>
    <textarea name="feedback_notes" placeholder="Feedback..."></textarea>
    <div class="taggz_feedback_submit_button">
      <button type="submit" class="taggz_button taggz_button_feedback">Send</button>
    </div>
  </form>
  <div class="taggz_support">
    <a href="https://www.taggz.art/cgi-bin/taggz.pl?action=sign_up_form&modal=terms" target="_blank">Terms and Conditions</a> & 
    <a href="https://www.taggz.art/cgi-bin/taggz.pl?action=sign_up_form&modal=privacy" target="_blank">Privacy Policy</a>
    <br>
    email: <a href="mailto:supportt@taggz.art">support@taggz.art</a>
  </div>
</div>
</div>
`;
document.body.appendChild(overlay);

const logoutButton = document.getElementById("taggz_logout-button");
logoutButton.addEventListener("click", () => {
  localStorage.removeItem('userData');
  chrome.storage.sync.remove('userData', () => {
    if (chrome.runtime.lastError) {
      console.error(chrome.runtime.lastError);
    } else {
    }
  });
  window.location.reload();
});

const closeIframeLogin = document.getElementById('closeButton');
closeIframeLogin.addEventListener("click", function () {
    overlay.style.display = "none";
});

function openSidebarWithIframe(tid, tname, tagid) {
  chromeStorage.get('userData', (result) => {
    if (chrome.runtime.lastError) {
      console.error(chrome.runtime.lastError);
    } else {
      const userData = result.userData;
      if (userData) {
        const tid = userData.tid;
        const tname = userData.tname;
        const tsite = window.location.href;
        const sidebar = document.getElementById('taggz_sidebar');
        sidebar.style.width = '325px'; 
        sidebar.style.right = '0';
        sidebar.innerHTML = '';
        const iframe = document.createElement('iframe');
        iframe.src = `https://taggz.art/cgi-bin/taggz.pl?action=sidebar_soulart&tid=${tid}&tagid=${tagid}&tname=${tname}&tsite=${tsite}`;
        iframe.style.width = '100%';
        iframe.style.height = '100%';
        iframe.setAttribute('allowtransparency', 'true'); 
        iframe.classList.add('taggz_transparent-iframe');
        iframe.setAttribute('name', 'sidebar');
        sidebar.appendChild(iframe);
        const closeSidebarButton = document.createElement('img');
        closeSidebarButton.src = chrome.runtime.getURL("img/icon_close.svg"); 
        closeSidebarButton.width = '24'; 
        closeSidebarButton.height = '24';
        closeSidebarButton.id = 'taggz_close-sidebar';
        closeSidebarButton.addEventListener('click', closeSidebar);
        sidebar.appendChild(closeSidebarButton);
      } else {
      }
    }
  });
}
function closeSidebar() {
  const sidebar = document.getElementById('taggz_sidebar');
  sidebar.style.width = '0'; 
  sidebar.style.right = '-325px'; 
}
const chatButton = document.getElementById('taggz_chat');
function openChatSidebarWithIframe(tid, tname) {
  chromeStorage.get('userData', (result) => {
    if (chrome.runtime.lastError) {
      console.error(chrome.runtime.lastError);
    } else {
      const userData = result.userData;
      if (userData) {
        const tid = userData.tid;
        const tname = userData.tname;
        const tsite = window.location.href;
        const sidebar = document.getElementById('taggz_sidebar');
        sidebar.style.width = '325px'; 
        sidebar.style.right = '0'; 
        sidebar.innerHTML = '';
        const iframe = document.createElement('iframe');        
        iframe.src = `https://taggz.art/cgi-bin/soulchat.pl?action=soulchat_feed&tid=${tid}&tname=${tname}&tsite=${tsite}&stid=&stname=`;
        iframe.style.width = '100%'; 
        iframe.style.height = '100%'; 
        iframe.setAttribute('allowtransparency', 'true');
        iframe.classList.add('taggz_transparent-iframe'); 
        iframe.setAttribute('name', 'sidebar');
        sidebar.appendChild(iframe);
        const closeSidebarButton = document.createElement('img');
        closeSidebarButton.src = chrome.runtime.getURL("img/icon_close.svg"); 
        closeSidebarButton.width = '24'; 
        closeSidebarButton.height = '24'; 
        closeSidebarButton.id = 'taggz_close-sidebar';
        closeSidebarButton.addEventListener('click', closeChatSidebar);
        sidebar.appendChild(closeSidebarButton);
      } else {
        console.error('userData is not available. No chat');
      }
    }
  });
}
function closeChatSidebar() {
  const sidebar = document.getElementById('taggz_sidebar');
  sidebar.style.width = '0'; 
  sidebar.style.right = '-325px'; 
}
const followButton = document.getElementById('taggz_follow');
function openFollowSidebarWithIframe(tid) {
  chromeStorage.get('userData', (result) => {
    if (chrome.runtime.lastError) {
      console.error(chrome.runtime.lastError);
    } else {
      const userData = result.userData;
      if (userData) {
        const tid = userData.tid;
        const tsite = window.location.href;
        const sidebar = document.getElementById('taggz_sidebar');
        sidebar.style.width = '325px';
        sidebar.style.right = '0'; 
        sidebar.innerHTML = '';
        const iframe = document.createElement('iframe');
        iframe.src = `https://taggz.art/cgi-bin/taggz.pl?action=sidebar_following&tid=${tid}&tsite=${tsite}`;
        iframe.style.width = '100%';
        iframe.style.height = '100%'; 
        iframe.setAttribute('allowtransparency', 'true'); 
        iframe.classList.add('taggz_transparent-iframe'); 
        iframe.setAttribute('name', 'sidebar');
        sidebar.appendChild(iframe);
        const closeSidebarButton = document.createElement('img');
        closeSidebarButton.src = chrome.runtime.getURL("img/icon_close.svg"); 
        closeSidebarButton.width = '24'; 
        closeSidebarButton.height = '24'; 
        closeSidebarButton.id = 'taggz_close-sidebar';
        closeSidebarButton.addEventListener('click', closeFollowSoulSidebar);
        sidebar.appendChild(closeSidebarButton);
      } else {
        console.error('userData is not available. No chat');
      }
    }
  });
}
function closeFollowSoulSidebar() {
  const sidebar = document.getElementById('taggz_sidebar');
  sidebar.style.width = '0'; 
  sidebar.style.right = '-325px'; 
}
const searchButton = document.getElementById('taggz_search');
function openSearchSidebarWithIframe(tid) {
  chromeStorage.get('userData', (result) => {
    if (chrome.runtime.lastError) {
      console.error(chrome.runtime.lastError);
    } else {
      const userData = result.userData;
      if (userData) {
        const tid = userData.tid;
        const tsite = window.location.href;
        const sidebar = document.getElementById('taggz_sidebar');
        sidebar.style.width = '325px';
        sidebar.style.right = '0'; 
        sidebar.innerHTML = '';
        const iframe = document.createElement('iframe');
        iframe.src = `https://taggz.art/cgi-bin/taggz.pl?action=sidebar_search&tid=${tid}&tsite=${tsite}`;
        iframe.style.width = '100%';
        iframe.style.height = '100%'; 
        iframe.setAttribute('allowtransparency', 'true'); 
        iframe.classList.add('taggz_transparent-iframe'); 
        iframe.setAttribute('name', 'sidebar');
        sidebar.appendChild(iframe);
        const closeSidebarButton = document.createElement('img');
        closeSidebarButton.src = chrome.runtime.getURL("img/icon_close.svg"); 
        closeSidebarButton.width = '24'; 
        closeSidebarButton.height = '24'; 
        closeSidebarButton.id = 'taggz_close-sidebar';
        closeSidebarButton.addEventListener('click', closeSearchSoulSidebar);
        sidebar.appendChild(closeSidebarButton);
      } else {
        console.error('userData is not available. No chat');
      }
    }
  });
}
function closeSearchSoulSidebar() {
  const sidebar = document.getElementById('taggz_sidebar');
  sidebar.style.width = '0'; 
  sidebar.style.right = '-325px'; 
}
const shopButton = document.getElementById('taggz_shop');
function openShopSidebarWithIframe(tid) {
  chromeStorage.get('userData', (result) => {
    if (chrome.runtime.lastError) {
      console.error(chrome.runtime.lastError);
    } else {
      const userData = result.userData;
      if (userData) {
        const tid = userData.tid;
        const tsite = window.location.href;
        const sidebar = document.getElementById('taggz_sidebar');
        sidebar.style.width = '325px';
        sidebar.style.right = '0'; 
        sidebar.innerHTML = '';
        const iframe = document.createElement('iframe');
        iframe.src = `https://taggz.art/cgi-bin/taggz.pl?action=sidebar_store&tid=${tid}&tsite=${tsite}`;
        iframe.style.width = '100%';
        iframe.style.height = '100%'; 
        iframe.setAttribute('allowtransparency', 'true'); 
        iframe.classList.add('taggz_transparent-iframe'); 
        iframe.setAttribute('name', 'sidebar');
        sidebar.appendChild(iframe);
        const closeSidebarButton = document.createElement('img');
        closeSidebarButton.src = chrome.runtime.getURL("img/icon_close.svg"); 
        closeSidebarButton.width = '24'; 
        closeSidebarButton.height = '24'; 
        closeSidebarButton.id = 'taggz_close-sidebar';
        closeSidebarButton.addEventListener('click', closeShopSoulSidebar);
        sidebar.appendChild(closeSidebarButton);
      } else {
        console.error('userData is not available. No chat');
      }
    }
  });
}
function closeShopSoulSidebar() {
  const sidebar = document.getElementById('taggz_sidebar');
  sidebar.style.width = '0'; 
  sidebar.style.right = '-325px'; 
}
const profileButton = document.getElementById('taggz_profile');
function openProfileSidebarWithIframe(tid) {
  chromeStorage.get('userData', (result) => {
    if (chrome.runtime.lastError) {
      console.error(chrome.runtime.lastError);
    } else {
      const userData = result.userData;
      if (userData) {
        const tid = userData.tid;
        const tsite = window.location.href;
        const sidebar = document.getElementById('taggz_sidebar');
        sidebar.style.width = '450px';
        sidebar.style.right = '0'; 
        sidebar.innerHTML = '';
        const iframe = document.createElement('iframe');
        iframe.src = `https://taggz.art/cgi-bin/souls.pl?action=profile_edit&tsite=${tsite}&tid=${tid}`;
        iframe.style.width = '100%';
        iframe.style.height = '100%';
        iframe.setAttribute('allowtransparency', 'true'); 
        iframe.classList.add('taggz_transparent-iframe'); 
        iframe.setAttribute('name', 'sidebar');
        sidebar.appendChild(iframe);
        const closeSidebarButton = document.createElement('img');
        closeSidebarButton.src = chrome.runtime.getURL("img/icon_close.svg"); 
        closeSidebarButton.width = '24'; 
        closeSidebarButton.height = '24'; 
        closeSidebarButton.id = 'taggz_close-sidebar';
        closeSidebarButton.addEventListener('click', closeProfileSoulSidebar);
        sidebar.appendChild(closeSidebarButton);
      } else {
        console.error('userData is not available. No chat');
      }
    }
  });
}
function closeProfileSoulSidebar() {
  const sidebar = document.getElementById('taggz_sidebar');
  sidebar.style.width = '0'; 
  sidebar.style.right = '-450px'; 
}
const adminButton = document.getElementById('taggz_admin');
function openAdminSidebarWithIframe(tid) {
  chromeStorage.get('userData', (result) => {
    if (chrome.runtime.lastError) {
      console.error(chrome.runtime.lastError);
    } else {
      const userData = result.userData;
      if (userData) {
        const tid = userData.tid;
        const tsite = window.location.href;
        const sidebar = document.getElementById('taggz_admin_sidebar');
        sidebar.style.width = '95%';
        sidebar.style.right = '0'; 
        sidebar.innerHTML = '';
        const iframe = document.createElement('iframe');
        iframe.src = `https://taggz.art/cgi-bin/admin.pl?action=admin_portal&tid=${tid}&tsite=${tsite}`;
        iframe.style.width = '100%';
        iframe.style.height = '100%'; 
        iframe.setAttribute('allowtransparency', 'true'); 
        iframe.classList.add('taggz_transparent-iframe'); 
        iframe.setAttribute('name', 'admin_sidebar');
        sidebar.appendChild(iframe);
        const closeSidebarButton = document.createElement('img');
        closeSidebarButton.src = chrome.runtime.getURL("img/icon_close.svg"); 
        closeSidebarButton.width = '24'; 
        closeSidebarButton.height = '24'; 
        closeSidebarButton.id = 'taggz_close-sidebar';
        closeSidebarButton.addEventListener('click', closeAdminSoulSidebar);
        sidebar.appendChild(closeSidebarButton);
      } else {
        console.error('userData is not available. No admin');
      }
    }
  });
}
function closeAdminSoulSidebar() {
  const sidebar = document.getElementById('taggz_admin_sidebar');
  sidebar.style.width = '0'; 
  sidebar.style.right = '0'; 
}

function renderSVGs(svgData) {
  const svgContainer = document.getElementById('taggz_svg-container');
  svgContainer.innerHTML = '';

  const validSvgData = svgData.filter(item => item.tagid);

  validSvgData.forEach(item => {
    const svgElement = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
    svgElement.setAttribute('width', `${item.tagw}px`);
    svgElement.setAttribute('height', `${item.tagh}px`);
    svgElement.style.position = 'absolute';
    svgElement.style.left = `${item.tagx}px`;
    svgElement.style.top = `${item.tagy}px`;
    const imageElement = document.createElementNS('http://www.w3.org/2000/svg', 'image');
    imageElement.setAttribute('width', '100%');
    imageElement.setAttribute('height', '100%');
    imageElement.setAttributeNS('http://www.w3.org/1999/xlink', 'href', `https://taggz.art/images/soulart/${item.tagid}.svg`);
    svgElement.addEventListener('click', () => {
      openSidebarWithIframe(item.tid, item.tname, item.tagid);
    });
    svgElement.appendChild(imageElement);
    svgContainer.appendChild(svgElement);
  });
}

function renderAvatarPNG(tid) {
  const avatarContainer = document.getElementById('taggz_avatar-container');
  const hasRenderedAvatar = localStorage.getItem('hasRenderedAvatar');
  const setFlagInLocalStorage = () => {
    localStorage.setItem('hasRenderedAvatar', true);
  };
  if (!hasRenderedAvatar) {
    const pngContainer = document.createElement('div');
    pngContainer.style.width = '100%';
    pngContainer.style.height = '100%';
    pngContainer.style.position = 'relative';
    const pngElement = new Image();
    const timestamp = Date.now();
    pngElement.src = `https://taggz.art/images/soulavatar/png/${tid}.png?ts=${timestamp}`;
    pngElement.id = 'taggz_avatar';
    pngContainer.appendChild(pngElement);
    avatarContainer.appendChild(pngContainer);
    pngContainer.addEventListener('click', () => {
      openSoulSidebarWithIframe();
    });
    setFlagInLocalStorage();
  chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
    if (message === 'tabActivated') {
      renderAvatarPNG(tid);
    }
  });
  } else {
  }
  window.addEventListener('beforeunload', () => {
    localStorage.removeItem('hasRenderedAvatar');
  });
}
const soulButton = document.getElementById('taggz_avatar');
function openSoulSidebarWithIframe(tid) {
  chromeStorage.get('userData', (result) => {
    if (chrome.runtime.lastError) {
      console.error(chrome.runtime.lastError);
    } else {
      const userData = result.userData;
      if (userData) {
        const tid = userData.tid;
        const tsite = window.location.href;
        const sidebar = document.getElementById('taggz_sidebar');
        sidebar.style.width = '90%'; 
        sidebar.style.right = '0'; 
        sidebar.innerHTML = '';
        const iframe = document.createElement('iframe');        
        iframe.src = `https://taggz.art/cgi-bin/taggz.pl?action=soulgear_store&tid=${tid}&tsite=${tsite}`;
        iframe.style.width = '100%'; 
        iframe.style.height = '100%'; 
        iframe.setAttribute('allowtransparency', 'true'); 
        iframe.classList.add('taggz_transparent-iframe'); 
        iframe.setAttribute('name', 'gear_up');
        sidebar.appendChild(iframe);
        const closeSidebarButton = document.createElement('img');
        closeSidebarButton.src = chrome.runtime.getURL("img/icon_close.svg"); 
        closeSidebarButton.width = '24'; 
        closeSidebarButton.height = '24'; 
        closeSidebarButton.id = 'taggz_close-sidebar';
        closeSidebarButton.addEventListener('click', closeSoulSidebar);
        sidebar.appendChild(closeSidebarButton);
      } else {
        console.error('userData is not available. No chat');
      }
    }
  });
}
function closeSoulSidebar() {
  chromeStorage.get('userData', (result) => {
    if (chrome.runtime.lastError) {
      console.error(chrome.runtime.lastError);
    } else {
      const userData = result.userData;
      if (userData) {
        const tid = userData.tid;
        const sidebar = document.getElementById('taggz_sidebar');
        sidebar.style.width = '0'; 
        sidebar.style.right = '0'; 
        const avatarImage = document.getElementById('taggz_avatar');
        const timestamp = Date.now();
        const newImageUrl = `https://taggz.art/images/soulavatar/png/${tid}.png?timestamp=${timestamp}`;
        avatarImage.src = newImageUrl;
      } else {
        console.error('userData is not available. No Sidebar');
      }
    }
  });
}
const toggleIcon = document.getElementById('taggz_toggle-icon');
const svgContainer = document.getElementById('taggz_svg-container');
function toggleSvgContainer() {
  isSvgContainerVisible = !isSvgContainerVisible;
  if (isSvgContainerVisible) {
    svgContainer.classList.remove('hidden');
  } else {
    svgContainer.classList.add('hidden');
  }
  if (isSvgContainerVisible) {
    toggleIcon.src = chrome.runtime.getURL("img/icon_toggle_on.svg");
    toggleIcon.classList.remove('off');
    toggleIcon.classList.add('on');
  } else {
    toggleIcon.src = chrome.runtime.getURL("img/icon_toggle_off.svg"); 
    toggleIcon.classList.remove('on');
    toggleIcon.classList.add('off');
  }
  chromeStorage.set({ 'isSvgContainerVisible': isSvgContainerVisible }, () => {
    if (chrome.runtime.lastError) {
      console.error(chrome.runtime.lastError);
    }
  });
}
function initializeToggleState() {
  if (!isSvgContainerVisible) {
    svgContainer.classList.add('hidden');
    toggleIcon.src = chrome.runtime.getURL("img/icon_toggle_off.svg"); 
    toggleIcon.classList.remove('on');
    toggleIcon.classList.add('off');
  }
  toggleIcon.addEventListener('click', toggleSvgContainer);
}
initializeToggleState();
const navWrapper = document.getElementById('taggz_nav-wrapper');
const pinButton = document.getElementById('taggz_pin-button');
function showNavigation() {
  navWrapper.style.left = '0';
}
function hideNavigation() {
  if (!isPinned) {
    navWrapper.style.left = '-56px';
  }
}
function toggleNavigation() {
  isPinned = !isPinned;
  chromeStorage.set({ isPinned }, () => {
    if (chrome.runtime.lastError) {
      console.error(chrome.runtime.lastError);
    }
  });
  if (isPinned) {
    pinButton.src = chrome.runtime.getURL("img/icon_pinned.svg");
    showNavigation();
  } else {
    pinButton.src = chrome.runtime.getURL("img/icon_unpinned.svg");
    hideNavigation();
  }
}
chromeStorage.get('isPinned', (result) => {
  if (chrome.runtime.lastError) {
    console.error(chrome.runtime.lastError);
    return;
  }
  if (result.isPinned === true) {
    toggleNavigation();
  }
});
pinButton.addEventListener("click", toggleNavigation);
navWrapper.addEventListener("mouseenter", () => {
  if (!isPinned) {
    showNavigation();
  }
});
navWrapper.addEventListener("mouseleave", () => {
  if (!isPinned) {
    hideNavigation();
  }
});
const overlayDraw = document.getElementById('taggz_draw-overlay');
const draw = document.getElementById('taggz_draw');
const iframeDraw = document.getElementById('taggz_iframe-draw'); 
const sidebar = document.getElementById('taggz_sidebar'); 
draw.addEventListener('click', () => {
    chromeStorage.get('userData', (result) => {
        if (chrome.runtime.lastError) {
            console.error(chrome.runtime.lastError);
        } else {
            const userData = result.userData;
            if (userData) {
                const tid = userData.tid;
                const tsite = window.location.href;
                const tagy2 = window.scrollY;
                const dynamicURL = `https://taggz.art/cgi-bin/taggz.pl?action=tagging&tsite=${tsite}&tid=${tid}&tagy2=${tagy2}`;
                iframeDraw.src = dynamicURL;
                overlayDraw.style.display = 'block';
                sidebar.style.display = 'none';
                navWrapper.style.display = 'none';
                document.body.style.overflow = 'hidden';
            } else {
                console.error('userData is not available. Tagging');
            }
        }
    });
});
function closeIframe() {
  overlayDraw.style.display = 'none';
  iframeDraw.src = ''; 
  sidebar.style.display = 'block';
  navWrapper.style.display = 'block';
  document.body.style.overflow = 'auto';
  renderAvatarPNG(tid);
}
window.addEventListener('message', (event) => {
  if (event.data === 'drawingComplete') {
    closeIframe();
    location.reload();
  }
});
window.addEventListener('message', (event) => {
  if (event.data === 'drawingCanceled') {
    closeIframe();
  }
});
window.addEventListener('scroll', () => {
  const scrollTop = window.scrollY;
  const svgContainer = document.getElementById('taggz_svg-container');
  svgContainer.style.transform = `translateY(-${scrollTop}px)`;
});
const inviteIcon = document.getElementById("taggz_invite_icon");
const inviteModal = document.getElementById("taggz_invite_modal");
const closeInvite = document.getElementById("taggz_close_invite");
function openModal() {
  inviteModal.style.display = "flex";
  feedbackModal.style.display = "none";
}
function closeModal() {
  inviteModal.style.display = "none";
}
inviteIcon.addEventListener("click", openModal);
closeInvite.addEventListener("click", closeModal);
const feedbackIcon = document.getElementById("taggz_feedback_icon");
const feedbackModal = document.getElementById("taggz_feedback_modal");
const closeFeedback = document.getElementById("taggz_close_feedback");
function openFeedbackModal() {
  feedbackModal.style.display = "block";
  inviteModal.style.display = "none";
}
function closeFeedbackModal() {
  feedbackModal.style.display = "none";
}
feedbackIcon.addEventListener("click", openFeedbackModal);
closeFeedback.addEventListener("click", closeFeedbackModal);
const slider = document.getElementById("feedbackSlider");
const sliderValue = document.getElementById("sliderValue");
const feedbackImage = document.getElementById("feedbackImage");
slider.addEventListener("input", function () {
  sliderValue.textContent = this.value;
  feedbackImage.src = chrome.runtime.getURL(`img/icon_feedback_${this.value}.svg`);
});
const feedbackForm = document.querySelector("form");
feedbackForm.addEventListener("submit", function (e) {
  e.preventDefault(); 
  const selectedValue = slider.value;
});
const inviteForm = document.getElementById("invite_form");
inviteForm.addEventListener("submit", function (e) {
  e.preventDefault(); 
 this.submit();
});
const taggzLeaderboard = document.getElementById('taggz_leaderboard');
if (taggzLeaderboard) {
  taggzLeaderboard.addEventListener('click', function () {
    chromeStorage.get('userData', (result) => {
      if (!chrome.runtime.lastError) {
        const userData = result.userData;
        if (userData && userData.tid) {
          const tid = userData.tid;
          const targetURL = 'https://taggz.art/cgi-bin/taggz.pl?action=leaderboards&tid=' + tid;
          window.location.href = targetURL;
        }
      }
    });
  });
}
function addJailBars() {
  chromeStorage.get('userData', (result) => {
    if (!chrome.runtime.lastError) {
      const userData = result.userData;
      if (userData && userData.tgame === 'Jail') {
        const avatarContainer = document.getElementById('taggz_avatar-container');
        if (avatarContainer) {
          // Set the border to red
          avatarContainer.style.border = '4px solid red';
          // avatarContainer.style.borderRadius = '2px';
          const jailBars = document.createElement('img');
          jailBars.id = 'jailcell';
          jailBars.src = chrome.runtime.getURL('img/bars.svg');
          const avatarDiv = avatarContainer.querySelector('div');
          if (avatarDiv) {
            avatarDiv.appendChild(jailBars);
          }
        }
      }
    }
  });
}


